<template>
  <Page actionBarHidden="true">
    <ScrollView>
      <StackLayout>
       <GridLayout>                    
            <Image width="350px" height="154,5px" marginTop="100px"
            marginBottom="50px"
            src="~/assets/images/logo.png"
            stretch="aspectFill" @tap="$router.push('/service')" />
        </GridLayout>
        <GridLayout>
            <Label textWrap="true"
                text="Placez le code Qr à l'intérieur de la zone."
                class="label" />
        </GridLayout>

        <GridLayout columns="*" rows="auto, auto, auto, auto">

          <BarcodeScanner
              row="1"
              height="300"
              formats="QR_CODE, EAN_13, UPC_A"
              beepOnScan="true"
              reportDuplicates="true"
              preferFrontCamera="false"
              @scanResult="onScanResult"
              v-if="isIOS">
          </BarcodeScanner>

          <Button row="2" class="btn btn-primary btn-rounded-sm" text="back camera, with flip" @tap="doScanWithBackCamera"></Button>

        </GridLayout>
      </StackLayout>
    </ScrollView>
  </Page>
</template>

<script>
  import {isIOS} from "tns-core-modules/platform";
  import {BarcodeScanner} from "nativescript-barcodescanner";
  export default {
    data() {
      return {
        isIOS
      }
    },
    methods: {
      onScanResult(evt) {
        console.log('onScanResult: ${evt.text} (${evt.format})');
      },
      doScanWithBackCamera() {
        this.scan(false);
      },
      scan(front) {
        new BarcodeScanner().scan({
          cancelLabel: "EXIT. Also, try the volume buttons!", // iOS only, default 'Close'
          cancelLabelBackgroundColor: "#333333", // iOS only, default '#000000' (black)
        //  message: "Use the volume buttons for extra light", // Android only, default is 'Place a barcode inside the viewfinder rectangle to scan it.'
          preferFrontCamera: front,     // Android only, default false
          showFlipCameraButton: true,   // default false
          showTorchButton: true,        // iOS only, default false
          torchOn: false,               // launch with the flashlight on (default false)
          resultDisplayDuration: 500,   // Android only, default 1500 (ms), set to 0 to disable echoing the scanned text
          beepOnScan: true,             // Play or Suppress beep on scan (default true)
          openSettingsIfPermissionWasPreviouslyDenied: true, // On iOS you can send the user to the settings app if access was previously denied
          closeCallback: () => {
            console.log("Scanner closed @ " + new Date().getTime());
          }
        }).then(
             (result) => {
              console.log("--- scanned: " + result.text);
              // Note that this Promise is never invoked when a 'continuousScanCallback' function is provided
              setTimeout( () => {
                // if this alert doesn't show up please upgrade to {N} 2.4.0+
                alert({
                  title: "Scan result",
                  message: "Format: " + result.format + ",\nValue: " + result.text,
                  okButtonText: "OK"
                });

              this.$router.push('/service', {scan: result.text});

              }, 500);
            },
            function (errorMessage) {
              console.log("No scan. " + errorMessage);
            }
        );
      }
    }
  }
</script>

<style scoped>
   .label {
        margin-bottom: 15;
        text-align: center;
        font-size: 20;
        color: #727272;
    }

    .com {
        margin: 130px 130px 130px 130px;
        height: 500px;
        border-color: #00A99D;
        background-color: #EBEBEB
    }

  .message {
    vertical-align: center;
    text-align: center;
    font-size: 20;
    color: #333333;
  }
</style>